SystemOrganization addCategory: #ConfigurationOfAdventureThing!

Object subclass: #ConfigurationOfAdventureThing
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfAdventureThing'!

!ConfigurationOfAdventureThing class methodsFor: 'development support' stamp: 'StuartHerring 11/25/2012 16:05'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfAdventureThing class methodsFor: 'private' stamp: 'StuartHerring 11/25/2012 16:05'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfAdventureThing class methodsFor: 'private' stamp: 'StuartHerring 11/25/2012 16:05'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfAdventureThing class methodsFor: 'private' stamp: 'StuartHerring 11/25/2012 16:05'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfAdventureThing class methodsFor: 'metacello tool support' stamp: 'StuartHerring 11/25/2012 16:05'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfAdventureThing class methodsFor: 'loading' stamp: 'StuartHerring 11/25/2012 16:05'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfAdventureThing class methodsFor: 'loading' stamp: 'StuartHerring 11/25/2012 16:05'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfAdventureThing class methodsFor: 'loading' stamp: 'StuartHerring 11/25/2012 16:05'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfAdventureThing class methodsFor: 'accessing' stamp: 'StuartHerring 11/25/2012 16:05'!
project

	^self new project! !

!ConfigurationOfAdventureThing class methodsFor: 'development support' stamp: 'StuartHerring 11/25/2012 16:05'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfAdventureThing methodsFor: 'baselines' stamp: 'StuartHerring 11/25/2012 16:06'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://stuartherring.net/mc/Caitlin'.
		spec 
			package: 'AdventureThing-Web';
			package: 'AdventureThing-Core'.
		spec group: 'default' with: #('AdventureThing-Web' 'AdventureThing-Core' ). ].
! !

!ConfigurationOfAdventureThing methodsFor: 'accessing' stamp: 'StuartHerring 11/25/2012 16:05'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfAdventureThing methodsFor: 'symbolic versions' stamp: 'StuartHerring 11/25/2012 16:05'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfAdventureThing methodsFor: 'accessing' stamp: 'StuartHerring 11/25/2012 16:05'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfAdventureThing methodsFor: 'versions' stamp: 'StuartHerring 11/25/2012 16:05'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: ''.
		spec author: 'StuartHerring'.
		spec timestamp: '11/25/2012 16:05'.
		spec 
			package: 'AdventureThing-Web' with: 'AdventureThing-Web-StuartHerring.4';
			package: 'AdventureThing-Core' with: 'AdventureThing-Core-StuartHerring.3'. ].
! !
